<template>
	<ProviderProductsNormalized v-slot="{ productsNormalized }" :items="[$props]">
		<BlockProductView
			ref="view"
			v-bind="{
				...$props,
				product: productsNormalized[0],
				priceMoney,
				currencySymbol,
			}"
			@affirm-updated="($event) => affirmUpdated($event)"
		/>
	</ProviderProductsNormalized>
</template>

<script>
import { mapGetters } from 'vuex';
import ProviderProductsNormalized from '@components/provider-products-normalized';
import BlockProductView from '@components/block-product-view';

const priceMoney = (dollars, currencySymbol) =>
	dollars ? `${currencySymbol}${dollars}` : '';

export default {
	components: {
		ProviderProductsNormalized,
		BlockProductView,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		name: {
			type: String,
			default: '',
		},

		sku: {
			type: String,
			default: '',
		},

		product: {
			type: Object,
			default: null,
		},

		discount: {
			type: Number,
			default: 0,
		},

		powerreviewsPageId: {
			type: String,
			default: '',
		},

		reviewsLink: {
			type: Object,
			default: null,
		},

		description: {
			type: [String, Array],
			default: '',
		},

		ctaText: {
			type: String,
			default: '',
		},

		ctaLink: {
			type: Object,
			default: null,
		},

		imageDesktop: {
			type: Object,
			default: null,
		},

		imageMobile: {
			type: Object,
			default: null,
		},

		watermarkImageDesktop: {
			type: Object,
			default: null,
		},

		watermarkImageMobile: {
			type: Object,
			default: null,
		},

		watermarkPosition: {
			type: String,
			default: 'Center',
		},

		watermarkWidth: {
			type: Number,
			default: 100,
		},

		watermarkHeight: {
			type: Number,
			default: 50,
		},

		watermarkOpacity: {
			type: Number,
			default: 0.5,
		},
	},

	computed: mapGetters(['currencySymbol']),

	methods: {
		priceMoney,

		affirmUpdated(el) {
			const bottom = el.querySelector('.affirm-pmt-bottom');
			if (bottom) {
				bottom.appendChild(document.createTextNode('. '));
				const trigger = el.querySelector('.affirm-modal-trigger');
				if (trigger) {
					bottom.appendChild(trigger);
				}

				const logo = bottom.querySelector('.__affirm-logo');
				if (logo) {
					logo.setAttribute('aria-hidden', 'true');
					logo.insertAdjacentHTML('afterend', '<span class="screen-reader-only">Affirm</span>');
				}

				const { view } = this.$refs;
				if (!view) return;

				const { affirmContainer } = view.$refs;
				if (!affirmContainer) return;

				while (affirmContainer.firstChild) {
					affirmContainer.removeChild(affirmContainer.firstChild);
				}

				affirmContainer.appendChild(bottom);
			}
		},
	},
};
</script>
